#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <PubSubClient.h>
#include <EEPROM.h>
extern "C" {
#include "user_interface.h"
}
#define LEDpin 2        // LED zum Blinken. Bei ESP-07 Pin 2. Bei ESP-01 Pin 1
#define DNS
IPAddress apIP(192, 168, 168, 30);

#if defined DNS
#include <DNSServer.h>
const byte DNS_PORT = 53;
DNSServer dnsServer;
#endif

char ssid[32] = "fhgdhfghd\0";
char passwort[64] = "gghdfgh\0";
String konfig[9];
#define BUFFER_SIZE 100

ESP8266WebServer server;
EspClass esp;
int z = 0;                   //Aktuelle EEPROM-Adresse zum lesen
#include "Setup2.h"
int SchaltZustandAlt = 1, Messinterval = 10;

WiFiClient wclient;
PubSubClient client(wclient);
void setup()                // Wird 1 Mal beim Start ausgefuehrt
{
  char inser;               // Serielle daten ablegen
  EEPROM.begin(512);                                 // EEPROM initialisieren mit 200 Byts

  //------------------------------------ Prüfen ob Tx und Rx verbunden sind --------------
  Serial.begin(115200);
  while (Serial.available())inser = Serial.read();
  Serial.println("Start");
  delay(10);
  inser = Serial.read();
  if (inser != 'S') goto weiter;
  inser = Serial.read();
  if (inser != 't') goto weiter;
  pinMode(LEDpin, OUTPUT);
  digitalWrite(LEDpin, 0);
  Einstellen();

weiter:
  z = 0;
  LeseEeprom(ssid, sizeof(ssid));        // EEPROM lesen
  if (ssid[0] > 127) // Wenn EEPROM leer ist dann:
  {
    for (int i = 0; i < 20; i++) EEPROM.write(i, '\0');
    EEPROM.commit();
    pinMode(LEDpin, OUTPUT);
    digitalWrite(LEDpin, 0);
    Einstellen();
  }
  LeseEeprom(passwort, sizeof(passwort));
  for (int k = 0; k < 7; k++) LeseEepromStr(&konfig[k], 60);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, passwort);
  int timout = 0;
  pinMode(LEDpin, OUTPUT);
  while (WiFi.status() != WL_CONNECTED)
  {
    timout++;
    if  (timout > 60) // Wenn Anmeldung nicht möglich
    {
      digitalWrite(LEDpin, 0);    // LED ON für 5 Sekunden
      delay(5000);
      digitalWrite(LEDpin, 1);
      esp.deepSleep(Messinterval * 60e6, WAKE_RFCAL);
      delay(100);
    }        // End timeout
    delay(300);
    digitalWrite(LEDpin, 0);
    delay(300);
    digitalWrite(LEDpin, 1);
  }                         // Verbunden

  Serial.begin(115200);
  Serial.println("");
  Serial.println("Start");
  pinMode(2, OUTPUT);
  digitalWrite(2, 0);
}


void loop()
{
  if (WiFi.status() == WL_CONNECTED)
  {
    if (!client.connected()) //------------------------- MQTT nicht verbunden ----------------------------------------
    {
      client.set_server(konfig[0], konfig[1].toInt());
      if (client.connect(MQTT::Connect(konfig[4]).set_auth(konfig[2], konfig[3])))
      {
        uint ADCValue = 0;

        for (int i = 0; i < 30; i++)
        {
          ADCValue += system_adc_read();
          delay(10);
          client.loop();
        }
        ADCValue = ADCValue / 30;

        String Antwort = String(ADCValue, DEC);
        client.publish(MQTT::Publish(konfig[5], Antwort).set_qos(0));
        client.loop();
        MQTT::Disconnect();
        Messinterval = konfig[6].toInt();
        esp.deepSleep(Messinterval * 60e6, WAKE_RFCAL);
      }
    } //----------------------------------------------- ende MQTT nicht verbunden -------------------------------------
    else
    {
      client.loop();
    }
  } // ende mit WLAN verbunden
  yield();
}




